# HeidiSQL Dump 
#
# --------------------------------------------------------
# Host:                 localhost
# Database:             yuri
# Server version:       4.1.22-community-nt
# Server OS:            Win32
# max_allowed_packet:   1048576
# HeidiSQL version:     3.0 RC3 Revision: 111
# --------------------------------------------------------

/*!40100 SET CHARACTER SET latin1;*/


#
# Table structure for table 'aethers'
#

CREATE TABLE /*!32312 IF NOT EXISTS*/ `aethers` (
  `char_id` int(10) unsigned NOT NULL default '0',
  `magic_id` int(10) unsigned NOT NULL default '0',
  `duration` int(10) unsigned NOT NULL default '0',
  `aether` int(10) unsigned NOT NULL default '0',
  `dummy_id` int(10) unsigned NOT NULL auto_increment,
  `pos` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`dummy_id`)
) ENGINE=MyISAM AUTO_INCREMENT=85218 DEFAULT CHARSET=latin1;



#
# Table structure for table 'char'
#

CREATE TABLE /*!32312 IF NOT EXISTS*/ `char` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(16) NOT NULL default '',
  `pass` varchar(16) NOT NULL default '',
  `ban` smallint(6) NOT NULL default '0',
  `clan_id` int(10) unsigned NOT NULL default '0',
  `clan_title` varchar(32) NOT NULL default '',
  `title` varchar(32) NOT NULL default '',
  `level` smallint(6) NOT NULL default '1',
  `class` smallint(6) NOT NULL default '0',
  `subclass` smallint(6) NOT NULL default '0',
  `totem` smallint(6) NOT NULL default '0',
  `might` smallint(6) NOT NULL default '5',
  `will` smallint(6) NOT NULL default '5',
  `grace` smallint(6) NOT NULL default '5',
  `karma` smallint(6) NOT NULL default '0',
  `hp` int(10) unsigned NOT NULL default '500',
  `max_hp` int(10) unsigned NOT NULL default '500',
  `mp` int(10) unsigned NOT NULL default '500',
  `max_mp` int(10) unsigned NOT NULL default '500',
  `exp` int(10) unsigned NOT NULL default '0',
  `money` int(10) unsigned NOT NULL default '0',
  `sex` smallint(6) NOT NULL default '0',
  `country` smallint(6) NOT NULL default '0',
  `face` smallint(6) NOT NULL default '0',
  `hair_color` smallint(6) NOT NULL default '0',
  `armor_color` smallint(6) NOT NULL default '0',
  `map` mediumint(8) unsigned NOT NULL default '0',
  `x` mediumint(8) unsigned NOT NULL default '0',
  `y` mediumint(8) unsigned NOT NULL default '0',
  `side` smallint(6) NOT NULL default '0',
  `state` smallint(6) NOT NULL default '0',
  `online` tinyint(4) NOT NULL default '0',
  `hair` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=103 DEFAULT CHARSET=latin1;



#
# Table structure for table 'clan'
#

CREATE TABLE /*!32312 IF NOT EXISTS*/ `clan` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(16) default '0',
  `master_id` int(11) unsigned default '0',
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



#
# Table structure for table 'equip'
#

CREATE TABLE /*!32312 IF NOT EXISTS*/ `equip` (
  `id` int(11) NOT NULL auto_increment,
  `char_id` int(11) unsigned NOT NULL default '0',
  `item_id` int(11) NOT NULL default '0',
  `amount` int(11) NOT NULL default '0',
  `dura` int(11) NOT NULL default '0',
  `owner_id` int(11) NOT NULL default '0',
  `real_name` varchar(64) NOT NULL default '',
  `vitaup_per` int(11) unsigned NOT NULL default '0',
  `manaup_per` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `char_id` (`char_id`)
) ENGINE=MyISAM AUTO_INCREMENT=451 DEFAULT CHARSET=latin1;



#
# Table structure for table 'gm'
#

CREATE TABLE /*!32312 IF NOT EXISTS*/ `gm` (
  `id` int(11) NOT NULL auto_increment,
  `char_id` int(11) unsigned NOT NULL default '0',
  `level` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `char_id` (`char_id`)
) ENGINE=MyISAM AUTO_INCREMENT=1215 DEFAULT CHARSET=latin1;



#
# Table structure for table 'inventory'
#

CREATE TABLE /*!32312 IF NOT EXISTS*/ `inventory` (
  `id` int(11) NOT NULL auto_increment,
  `char_id` int(11) unsigned NOT NULL default '0',
  `item_id` int(11) NOT NULL default '0',
  `amount` int(11) NOT NULL default '0',
  `dura` int(11) NOT NULL default '0',
  `owner_id` int(11) NOT NULL default '0',
  `real_name` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `char_id` (`char_id`)
) ENGINE=MyISAM AUTO_INCREMENT=1951 DEFAULT CHARSET=latin1;



#
# Table structure for table 'legends'
#

CREATE TABLE /*!32312 IF NOT EXISTS*/ `legends` (
  `char_id` int(11) NOT NULL default '0',
  `icon` tinyint(3) NOT NULL default '0',
  `color` tinyint(3) NOT NULL default '0',
  `text` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



#
# Table structure for table 'magic'
#

CREATE TABLE /*!32312 IF NOT EXISTS*/ `magic` (
  `char_id` int(11) NOT NULL default '0',
  `magic_id` int(11) NOT NULL default '0',
  `dummy_id` int(11) NOT NULL auto_increment,
  `pos` int(11) NOT NULL default '0',
  PRIMARY KEY  (`dummy_id`)
) ENGINE=MyISAM AUTO_INCREMENT=40467 DEFAULT CHARSET=latin1;



#
# Table structure for table 'option'
#

CREATE TABLE /*!32312 IF NOT EXISTS*/ `option` (
  `char_id` int(11) unsigned default '0',
  `allow_whisper` tinyint(1) unsigned default '1',
  `allow_exchange` tinyint(1) unsigned default '1',
  `allow_pvp` tinyint(1) unsigned default '1',
  `allow_group` tinyint(1) unsigned default '1',
  `eff_magic` tinyint(1) unsigned default '1',
  `eff_sound` tinyint(1) unsigned default '1',
  `eff_weather` tinyint(1) unsigned default '1',
  `showhelm` tinyint(1) unsigned default '1',
  `fastmove` tinyint(1) unsigned default '1',
  `announce` tinyint(1) unsigned default '1'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



#
# Table structure for table 'reg'
#

CREATE TABLE /*!32312 IF NOT EXISTS*/ `reg` (
  `char_id` int(11) unsigned NOT NULL default '0',
  `name` varchar(32) NOT NULL default '',
  `val` text NOT NULL,
  KEY `char_id` (`char_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

