
#include "crypt.h"

static char encKey[] = "NexonInc.";

// XOR Crypt Code
//----------------------------
/*
int crypt(char *packet)
{
	register int i,j;
	register char *temp;
	register int size,groups;
	if(packet==0) return -1;
	
	temp=packet+5;
	size=packet[1]*256+packet[2]-2;
	groups = size / 9;
	groups++;
	for( i=0;i<size;i++ )
		temp[i] = (temp[i]^encKey[i%9]);
	for( i=0;i<groups;i++ ) for( j=0;j<9;j++ ){
		register int k=i*9+j;
		if( k >= size ) break;	
		temp[k] = ((temp[k])^( (i%256==packet[4])? 0:i%256));
	}
	for( i=0;i<size;i++ )
		temp[i] = (temp[i] ^ packet[4]);
	return size+5;
}*/

int crypt( char *packet )
{
	int size;
	unsigned char increment;
	char *temp;
	register int i, j;
	if(packet==0) return -1;
	
	temp=packet+5;
	size=((unsigned char)*(packet+1)<<8|(unsigned char)*(packet+2))-2;
	increment=*(packet+4);

	for( i=0;i<size;i++ ) {
		temp[i]=(temp[i]^encKey[i%9]);
		j=(i/9)&0xFF;
		temp[i]=( temp[i]^(( j==increment )?0:j) );	
		temp[i]=(temp[i]^increment); 
	}
	return size+5;
}