#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../common/core.h"
#include "../common/socket.h"
#include "../common/crypt.h"
#include "../common/malloc.h"
#include "login.h"
#include "intif.h"

#include "clif.h"


int clif_accept(int fd) {
	
	memcpy(WFIFOP(fd,0),"\xAA\x00\x13\x7E\x1B\x43\x4F\x4E\x4E\x45\x43\x54\x45\x44\x20\x53\x45\x52\x56\x45\x52\x0A",22);
	WFIFOSET(fd, 22);
	
//	memcpy(WFIFOP(fd,0),"\xAA\x00\x85\x6F\x00\x4F\x65\x70\x61\x3C\x20\x0A\x02\x4C\x23\x01\x38\x00\x06\x25\x0E\x0E\x5C\xCB\xDD\x76\xF3\x66\x0C\x1E\x0E\x59\x3D\x28\x1A\x01\x08\x39\x7D\x96\xE9\x38\x68\x35\x1F\x0F\x20\x23\x09\x4C\x24\x50\x32\x3A\x94\xA1\x60\x25\x43\x29\x11\x17\x0A\x21\x21\x0E\x0A\x18\x9D\x9E\x52\x08\x62\x0D\x01\x05\x5B\x2F\x0E\x39\x09\x00\x2E\x57\x7C\xA2\xA7\x39\x7A\x25\x0F\x21\x15\x03\x44\x0D\x01\x14\x0A\x56\xD4\xF1\xAB\xCF\x4E\x2D\x1B\x05\x17\x2B\x06\x21\x4B\x24\x06\x47\x72\x7A\x01\xD4\x64\x61\x2C\x04\x19\x07\x00\x30\x0A\x01\x4D\x33\xC1\x0D\xF3\x2D",136);
//	WFIFOSET(fd,136);

	return 0;
}

int clif_message(int fd, char code, char *buff) {
	int packet_len = strlen(buff)+6;
	WFIFOB(fd, 0) = 0xAA;
	WFIFOW(fd, 1) = SWAP16(packet_len);
	WFIFOB(fd, 3) = 0x02;
	WFIFOB(fd, 4) = 0x02;
	WFIFOB(fd, 5) = code;
	WFIFOB(fd, 6) = strlen(buff);
	strcpy(WFIFOP(fd, 7), buff);
	WFIFOW(fd, packet_len+3) = 0x00;
	crypt(WFIFOP(fd, 0));
	WFIFOSET(fd, packet_len+3);
	return 0;
}

int clif_parse(int fd) {
	unsigned short len;
	struct login_session_data *sd;
	
	if(session[fd]->eof) {
		do_close(fd);
		return 0;
	}

	if(!session[fd]->session_data)
		CREATE(session[fd]->session_data, struct login_session_data, 1);

	sd = session[fd]->session_data;

	if (RFIFOB(fd, 0) != 0xAA) {
		int head_err=0;
		while (RFIFOB(fd, 0) != 0xAA && RFIFOREST(fd)) {
			RFIFOSKIP(fd, 1);
			if (head_err++ > 30) {
				session[fd]->eof=1;
				return 0;
			}
		}
	}

	if (RFIFOREST(fd) < 3)
		return 0;

	len = SWAP16(RFIFOW(fd, 1)) + 3;
	
	while( RFIFOB(fd,0) == 0xAA // processing parse if there are remained packets [Lene]
		&& RFIFOREST(fd) >= len ) {	// when it comes completly [Lene]
		
		if(RFIFOB(fd,3) != 0x00) len=crypt(RFIFOP(fd, 0));
		
		switch (RFIFOB(fd, 3)) {
		case 0x00:
			{
				unsigned short version;
				version=SWAP16(RFIFOW(fd, 4));
				//{ int i; for( i=0;i< 10;i++) printf("%d ",RFIFOB(fd,i)); printf("\n");}
				//printf("version:%d,%x\n",version,version);

			//	if(version!=651) {
				//	printf("%d ver client connected, closed socket\n",version);
				//	do_close(fd);
			//		return 0;
			//	} 
				session[fd]->session_data2=0;
				
				/*
				WFIFOB(fd, 0) = 0xAA;
				WFIFOB(fd, 1) = 0x00;
				WFIFOB(fd, 2) = 0x07;
				WFIFOB(fd, 3) = 0x00;
				WFIFOB(fd, 4) = 0x00;
				WFIFOB(fd, 5) = 0x42;
				WFIFOB(fd, 6) = 0xF9;
				WFIFOB(fd, 7) = 0x1D;
				WFIFOB(fd, 8) = 0x63;
				WFIFOB(fd, 9) = 0x00;
				WFIFOSET(fd, 10);
				*/
			}
			break;
		case 0x02:
			
			memset(sd->name, 0, 16);
			memset(sd->pass, 0, 16);
			if ( RFIFOB(fd, 5) > 12) {
				clif_message(fd, 0x03, login_msg[LGN_ID_TOOLONG]);
				break; 
			} else if( RFIFOB(fd, 5) < 4 ) {
				clif_message(fd, 0x03, login_msg[LGN_ID_TOOSHORT]);
				break;
			}
			if (RFIFOB(fd, 6+RFIFOB(fd, 5)) > 15 ) {
				clif_message(fd, 0x05, login_msg[LGN_PW_TOOLONG]);
				break;
			} else if(RFIFOB(fd, 6+RFIFOB(fd, 5)) < 4) {
				clif_message(fd, 0x05, login_msg[LGN_PW_TOOSHORT]);
				break;
			}
			
			
			
			memcpy(sd->name, RFIFOP(fd, 6), RFIFOB(fd, 5));
			memcpy(sd->pass, RFIFOP(fd, 7+RFIFOB(fd, 5)), RFIFOB(fd, 6+RFIFOB(fd, 5)));
			if( !hangul_check( sd-> name) ) { 
				clif_message(fd, 0x05, login_msg[LGN_PW_TOOSHORT]);
				break;
				
			}
			
			if (char_fd) {
				
				
				WFIFOB(char_fd, 0) = 0x01;
				WFIFOW(char_fd, 1) = fd;
				memcpy(WFIFOP(char_fd, 3), sd->name, 16);
				WFIFOSET(char_fd, 19);
			} else {
				clif_message(fd, 0x03, login_msg[LGN_ERRDB]);
			}

			break;
		case 0x03:
		/*
		if (string_check(RFIFOP(fd, 6),RFIFOB(fd, 5))) {
		clif_message(fd, 0x03, login_msg[LGN_ERRUSER]);
		break;
		}
		
		  
			if (string_check(RFIFOP(fd, 7+RFIFOB(fd, 5)),RFIFOB(fd, 6+RFIFOB(fd, 5)))) {
			clif_message(fd, 0x05, login_msg[LGN_ERRPASS]);
			break;
			}
			*/

			if (char_fd) {
				//printf("Sent information to thing.");

				WFIFOB(char_fd, 0) = 0x03;
				WFIFOW(char_fd, 1) = fd;
				memset(WFIFOP(char_fd, 3), 0, 16*2);
				memcpy(WFIFOP(char_fd, 3), RFIFOP(fd, 6), RFIFOB(fd, 5));
				memcpy(WFIFOP(char_fd, 19), RFIFOP(fd, 7+RFIFOB(fd, 5)), RFIFOB(fd, 6+RFIFOB(fd, 5)));
				WFIFOL(char_fd, 35) = session[fd]->client_addr.sin_addr.s_addr;
				WFIFOSET(char_fd, 39);
			} else {
				clif_message(fd, 0x03, login_msg[LGN_ERRDB]);
			}		
			break;
			
		case 0x04:
			if (!strlen(sd->name))
				session[fd]->eof = 1;
			
			sd->body = RFIFOB(fd, 6);
			sd->sex	= RFIFOB(fd, 8);
			sd->country = RFIFOB(fd, 9);
			sd->totem = RFIFOB(fd, 10);
			sd->hair = RFIFOB(fd,7);
/*
			if( sd->sex > 2 ||
				sd->country > 2 ||
				sd->totem > 3) {
				// someone trying to crash the server...
				do_close(fd);
				return 0;
			}
*/			
			printf("MAKING ACCOUNT: sex=%d | body=%d | country=%d | totem=%d | hair=%d\n",sd->sex,sd->body,sd->country,sd->totem,sd->hair);
			if (char_fd) {
				WFIFOB(char_fd, 0) = 0x02;
				WFIFOW(char_fd, 1) = fd;
				memcpy(WFIFOP(char_fd, 3), sd->name, 16);
				memcpy(WFIFOP(char_fd, 19), sd->pass, 16);
				WFIFOB(char_fd, 35) = sd->body;
				WFIFOB(char_fd, 36) = sd->sex;
				WFIFOB(char_fd, 37) = sd->country;
				WFIFOB(char_fd, 38) = sd->totem;
				WFIFOB(char_fd, 39) = sd->hair;
				WFIFOSET(char_fd, 40);
			} else {
				clif_message(fd, 0x03, login_msg[LGN_ERRDB]);
			}
			break;
			/*
			case 0x26:
			if (string_check(RFIFOP(fd, 6),RFIFOB(fd, 5))) {
			clif_message(fd, 0x03, login_msg[LGN_ERRUSER]);
			break;
			}
			if (string_check(RFIFOP(fd, 7+RFIFOB(fd, 5)),RFIFOB(fd, 6+RFIFOB(fd, 5))) || string_check(RFIFOP(fd, 8+RFIFOB(fd, 5)+RFIFOB(fd, 6 + RFIFOB(fd, 5))), RFIFOB(fd, 7 + RFIFOB(fd, 5) + RFIFOB(fd, 6 + RFIFOB(fd, 5))))) {
			clif_message(fd, 0x05, login_msg[LGN_ERRPASS]);
			break;
			}
			if (char_fd) {
			WFIFOB(char_fd, 0) = 0x04;
			WFIFOW(char_fd, 1) = fd;
			memset(WFIFOP(char_fd, 3), 0, 16*3);
			memcpy(WFIFOP(char_fd, 3), RFIFOP(fd, 6), RFIFOB(fd, 5));
			memcpy(WFIFOP(char_fd, 19), RFIFOP(fd, 7+RFIFOB(fd, 5)), RFIFOB(fd, 6+RFIFOB(fd, 5)));
			memcpy(WFIFOP(char_fd, 35), RFIFOP(fd, 8+RFIFOB(fd, 5)+RFIFOB(fd, 6 + RFIFOB(fd, 5))), RFIFOB(fd, 7 + RFIFOB(fd, 5) + RFIFOB(fd, 6 + RFIFOB(fd, 5))));
			WFIFOSET(char_fd, 51);
			} else {
			clif_message(fd, 0x03, login_msg[LGN_ERRDB]);
			}
			break;
			*/
		case 0x71: //ping me!
			break;
		case 0x62: //??
			memcpy(WFIFOP(fd,0),"\xAA\x00\x04\x66\x00\x00\x00",7);		
			WFIFOSET(fd,crypt(WFIFOP(fd,0)));
			break;
			
		case 0xFF:
			intif_auth(fd);
			break;
		default:
			if (dump_save)
				add_dmp(fd, len);
			break;
	}
	
	RFIFOSKIP(fd, len);
	}
	return 0;
}
