
#ifndef _CLIF_H_
#define _CLIF_H_

#include <stdarg.h>
#include "../common/mmo.h"

enum { ALL_CLIENT, SAMESRV, SAMEMAP, SAMEMAP_WOS, AREA, AREA_WOS, SAMEAREA, SAMEAREA_WOS, CORNER, SELF };
enum { LOOK_GET, LOOK_SEND };
int clif_send_pc_health(struct map_sessiondata*,struct map_sessiondata*,int,int);
int clif_findspell_pos(struct map_sessiondata*,int);
int clif_calc_critical(struct map_sessiondata*);
int clif_has_aethers(struct map_sessiondata*,int);
int clif_send_sub(struct block_list*, va_list);
int clif_send(unsigned char*,int,struct block_list*,int);
int clif_battle_values(struct map_sessiondata*,struct mobspawn_data*,int);
int clif_charlook_sub(struct block_list*,va_list);
int clif_charlook_sub2(struct block_list *bl, va_list ap);
int clif_itemlook_sub(struct block_list*,va_list);
int clif_npc_look(struct block_list*,va_list);
int clif_mob_look(struct block_list*,va_list);
int clif_mob_move(struct block_list*,va_list);
int clif_mob_damage(struct block_list*,va_list);
int clif_send_mob_health(struct mobspawn_data*,struct map_sessiondata*,int,int);
int clif_mob_kill(struct map_sessiondata*, struct mobspawn_data*);
int clif_send_destroy(struct block_list*,va_list);
int clif_sendtest(struct map_sessiondata*);
int clif_sendmob_action(struct mobspawn_data*,int,int,int);
int clif_sendmob_side(struct mobspawn_data*);
int clif_handle_bfp(struct map_sessiondata*,int,int);
int clif_mob_damage2(struct block_list *bl, struct map_sessiondata *sd);
//send func
int clif_sendanimation(struct block_list*,va_list);
int clif_sendequip(struct map_sessiondata*,int);
int clif_sendadditem(struct map_sessiondata*,int);
int clif_senddelitem(struct map_sessiondata*,int,int);
int clif_sendminitext(struct map_sessiondata*,char*,int);
int clif_sendwisp(struct map_sessiondata*,char*,unsigned char*,int);
int clif_retrwisp(struct map_sessiondata*,char*,unsigned char*,int);
int clif_failwisp(struct map_sessiondata*, const char*);
int clif_sendsay(struct map_sessiondata*,char*,int,int);
int clif_sendmsg(struct map_sessiondata*,int,char*,int);
int clif_sendack(struct map_sessiondata*);
int clif_sendtime(struct map_sessiondata*);
int clif_sendid(struct map_sessiondata*);
int clif_sendmapinfo(struct map_sessiondata*);
int clif_sendxy(struct map_sessiondata*);
int clif_sendstatus(struct map_sessiondata*);
int clif_sendupdatestatus(struct map_sessiondata*);
int clif_sendmapdata(struct map_sessiondata*,int,int,int,int,int,unsigned short);
int clif_sendside(struct map_sessiondata*);
int clif_quit(struct map_sessiondata*);
int clif_spawn(struct map_sessiondata*);
int clif_getchararea(struct map_sessiondata*);
int clif_getitemarea(struct map_sessiondata*);
int clif_sendchararea(struct map_sessiondata*);
int clif_sendaction(struct map_sessiondata*,int,int,int);
int clif_lookgone(struct block_list*);
int clif_sendchararea2(struct map_sessiondata *sd);
//parse func
int clif_parsechangepos(struct map_sessiondata*);
int clif_parseattack(struct map_sessiondata*);
int clif_parsewisp(struct map_sessiondata*);
int clif_parseside(struct map_sessiondata*);
int clif_parsewalk(struct map_sessiondata*);
int clif_parseemotion(struct map_sessiondata*);
int clif_parsemap(struct map_sessiondata*);
int clif_parsesay(struct map_sessiondata*);
int clif_parsegetitem(struct map_sessiondata*);
int clif_parsedropitem(struct map_sessiondata*);
int clif_parseuseitem(struct map_sessiondata*);
int clif_parseunequip(struct map_sessiondata*);
int clif_sendbluemessage(struct map_sessiondata*,char*);
//script func
int clif_scriptmes(struct map_sessiondata*,int, char*,int,int);
int clif_accept(int);
int clif_parse(int);
int clif_scriptmenu(struct map_sessiondata*, int, char*,char*[],int);
int clif_parsemenu(struct map_sessiondata*);
int clif_sendmagic(struct map_sessiondata*,int);
int clif_parsemagic(struct map_sessiondata*);
int clif_mystaytus(struct map_sessiondata*);
int clif_send_aether(struct map_sessiondata*,int,int);

//
int pc_damage(struct block_list*,va_list);
int pc_damage2(struct block_list *bl,struct map_sessiondata *sd);
int clif_walkback(struct map_sessiondata *sd);
int clif_parsetoggle(struct map_sessiondata *sd);
int clif_senduserinfo(struct map_sessiondata *sd, struct map_sessiondata *src);
int clif_sendsound(struct map_sessiondata *sd, int sound);

#endif
