
#ifndef _CHAR_H_
#define _CHAR_H_

#define USE_DB_MYSQL

#include "../common/mmo.h"

struct char_login_data {
	char name[16];
	int map_server;
};

struct map_fifo_data {
	int fd;
	unsigned int ip, port;
	unsigned short map[MAX_MAP_PER_SERVER];
	unsigned int map_n;
};


extern struct map_fifo_data map_fifo[];
extern int map_fifo_max;
extern int map_fifo_n;

extern int start_money;
extern struct point start_pos;

extern int login_fd;
extern char login_id[];
extern char login_pw[];

extern char char_id[];
extern char char_pw[];
extern int login_ip;
extern unsigned short login_port;
struct char_login_data* logindata_search(unsigned int);
int logindata_add(unsigned int,int,char*);
int logindata_del(unsigned int);
int logindata_change(unsigned int,int);
int mapfifo_from_mapid(int);

int config_read(const char*);

void do_term(void);
int mmo_save_reg(unsigned int id, struct registry *reg);
#endif
