
#ifndef _CHAR_DB_H_
#define _CHAR_DB_H_

#include "../common/mmo.h"

extern void char_db_init();
extern void char_db_term();
extern int char_db_newchar(const char*,const char*,int,int,int,int,int);
extern int char_db_isnameused(const char*);
extern unsigned int char_db_idfromname(const char *name);
extern int char_db_setpass(const char*,const char*,const char*);
extern int char_db_mapfifofromlogin(const char*,const char*,unsigned int*);
extern int mmo_char_fromdb(unsigned int,struct mmo_charstatus*,char*);
extern int mmo_char_todb(struct mmo_charstatus*);
extern void mmo_setonline(unsigned int,int);
extern void mmo_setallonline(int);
int mmo_request_reg(unsigned int id, struct registry *reg);
int mmo_save_reg(unsigned int id, struct registry *reg);
int mmo_request_legend(unsigned int id, struct legends *leg);
#endif
