
#ifndef _SQL_H_
#define _SQL_H_

void sql_init();
void sql_close();
int sql_request(const char *format, ...);
int sql_get_row();
void sql_free_row();
unsigned int sql_num_row();
char *sql_get_str(int);
int sql_get_int(int);
unsigned int sql_get_uint(int);

void sql_set_port(int);
void sql_set_ip(const char*);
void sql_set_id(const char*);
void sql_set_pw(const char*);
void sql_set_db(const char*);

#endif
