
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../common/db.h"
#include "../common/malloc.h"
#include "../common/core.h"

#include "class_db.h"
#include "map.h"
#include "script.h"
#include "../common/nullpo.h"

#define MIGHT 0
#define WILL 0
#define GRACE 0

unsigned int exp_require[6][100];

struct class_data class[6][10]={ 
	{ 
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
	},{
		{ "", 4 },
		{ "˰", 4 },
		{ "", 4 },
		{ "Ȳ", 4 },
		{ "˼", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
	},{
		{ "", 4 },
		{ "ڰ", 4 },
		{ "", 4 },
		{ "Ͱ", 4 },
		{ "¼", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
	},{
		{ "ּ", 6 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
	},{
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
	},{
		{ "", 6 },
		{ "", 6 },
		{ "", 6 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
		{ "", 4 },
	}
};



struct class_data *get_classdb(int class_id,int subclass) {
	return &class[class_id][subclass];
}

	
int classdb_read(const char *classdb_file) {
	FILE *fp;
	char line[1024];
	int lines=0;
	int id,sub;
	char *str[18], *p, *np;
	int i, cls=0;
	int x;

	/*
	fp = fopen(classdb_file, "r");
	if (fp==NULL) {
		printf("DB_ERR: Can't read class db (%s).", classdb_file);
		exit(1);
	}

	while (fgets(line,sizeof(line),fp)) {
		lines++;
		if (line[0] == '/' && line[1] == '/')
			continue;
		memset(str,0,sizeof(str));
		for(i=0,np=p=line;i<3 && p;i++) {
			str[i]=p;
			p=strchr(p,',');
			if(p){ *p++=0; np=p; }
		}
		


	}

	fclose(fp);

	printf("Class db read done. %d classes loaded!\n", cls);
	*/
	return 0;
}
int leveldb_read(const char *leveldb_file) {
	FILE *fp;
	char line[1024];
	char *str[100], *p, *np;
	int i,id,sub;
	fp = fopen(leveldb_file, "r");
	if (fp==NULL) {
		printf("DB_ERR: Can't read level db (%s).", leveldb_file);
		exit(1);
	}

	while (fgets(line,sizeof(line),fp)) {
		if (line[0] == '/' && line[1] == '/')
			continue;
		memset(str,0,sizeof(str));

		// id,level,exp
		for(i=0,np=p=line;i<6 && p;i++) {
			str[i]=p;
			p=strchr(p,',');
			if(p){ *p++=0; np=p; }
		}
		
		id=atoi(str[0]);
		sub=atoi(str[1]);

		exp_require[id][sub]=atoi(str[2]);
//		base[id][sub][0]=atoi(str[3]);
//		base[id][sub][1]=atoi(str[4]);
//		base[id][sub][2]=atoi(str[5]);
//		base_vita[id][sub]=atoi(str[6]);
//		base_mana[id][sub]=atoi(str[7]);
		

	}

	fclose(fp);
	printf("Level db read done.\n");
	return 0;
}
static int classdb_final(void *key,void *data,va_list ap) {

	return 0;
}

int classdb_term() {

	return 0;
}

int classdb_init() {

	classdb_read(CLASSDB_FILE);
	leveldb_read(LEVELDB_FILE);
	return 0;
}

