
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "../common/mmo.h"
#include "map.h"
#include "pc.h"
#include "clif.h"
#include "command.h"
#include "itemdb.h"
#include "magic.h"

//for debug command
#include "../common/socket.h"
#include "../common/crypt.h"

char command_code='/';
int command_debug(struct map_sessiondata*,char*);
int command_helm(struct map_sessiondata*,char*);
int command_item(struct map_sessiondata*,char*);
int command_res(struct map_sessiondata*,char*);
int command_hair(struct map_sessiondata*,char*);
int command_xprate(struct map_sessiondata*,char*);
int command_heal(struct map_sessiondata*,char*);
int command_level(struct map_sessiondata*,char*);
int command_randomspawn(struct map_sessiondata*,char*);
int command_drate(struct map_sessiondata*,char*);
int command_spell(struct map_sessiondata*,char*);
int command_val(struct map_sessiondata*,char*);
int command_mon(struct map_sessiondata*,char*);
int command_disguise(struct map_sessiondata*,char*);
int command_warp(struct map_sessiondata*,char*);
int command_makegm(struct map_sessiondata*,char*);
int command_givespell(struct map_sessiondata*,char*);
int command_side(struct map_sessiondata*,char*);
int command_state(struct map_sessiondata*,char*);
int command_armorcolor(struct map_sessiondata*,char*);
int command_makegm(struct map_sessiondata*,char*);
int command_who(struct map_sessiondata*,char*);
int command_packettest(struct map_sessiondata*,char*);
int command_sound(struct map_sessiondata*, char*);
int command_scriptreload(struct map_sessiondata*, char*);
int command_worldmaptest(struct map_sessiondata *sd, char *a);
int command_helm(struct map_sessiondata*, char*);
int command_addlegend(struct map_sessiondata*, char*);
int command_dellegend(struct map_sessiondata*, char*);
int command_modifylegend(struct map_sessiondata*, char*);

struct {
	int (*func)(struct map_sessiondata*,char*);
	char *name;
} command[]= {
	{command_debug,"debug"},
	{command_item,"Ӿ"},
	{command_res,"Ȱ"},
	{command_hair,"Ӹٲٱ"},
	{command_xprate,"ġ"},
	{command_heal,"ȸ"},
	{command_level,"ٲٱ"},
	{command_randomspawn,""},
	{command_drate,""},
	{command_spell,"Ʈ"},
	{command_val,"val"},
	{command_mon,"mon"},
	{command_disguise,"Ǻ"},
	{command_warp,"̵"},
	{command_givespell,""},
	{command_side,"side"},
	{command_state,"state"},
	{command_armorcolor,"ǻ󿰻"},
	{command_makegm,"ֱ"},
	{command_who,""},
	{command_sound,""},
	{command_item,""},
	{command_scriptreload,"ũƮٽб"},
	{command_worldmaptest,""},
	{command_helm,""},
	{command_packettest,"Ŷ"},
	{command_addlegend,"addl"},
	{command_modifylegend,"modifyl"},
	{command_dellegend,"dell"},
	{NULL,NULL}
};

struct userlist_data userlist;

int command_helm(struct map_sessiondata *sd, char *line) {
	unsigned int g=0,g_c=0;
	if (sscanf(line,"%255d %255d",&g,&g_c)<1)
		return -1;
//	sd->tmp=g;
//	sd->tmp2=g_c;
//	clif_sendchararea(sd);
	
	return 0;
}
int command_packettest(struct map_sessiondata* sd,char* line) {
	char *str[1024], *p, *np;
	int i, mstr=0;
	for(i=0,np=p=line;i<15 && p;i++) {
		str[i]=p;
		p=strchr(p,' ');
		if(p){ *p++=0; np=p; }
	}
	WFIFOB(sd->fd, 0) = 0xAA;
	WFIFOW(sd->fd, 1) = SWAP16(16);
	WFIFOB(sd->fd, 3) = 0x23;
	WFIFOB(sd->fd, 4) = 3;
	WFIFOB(sd->fd, 5) = (str[0])? atoi(str[0]):0;
	WFIFOB(sd->fd, 6) = (str[1])? atoi(str[1]):0;
	WFIFOB(sd->fd, 7) = (str[2])? atoi(str[2]):0;
	WFIFOB(sd->fd, 8) = (str[3])? atoi(str[3]):0;
	WFIFOB(sd->fd, 9) = (str[4])? atoi(str[4]):0;
	WFIFOB(sd->fd, 10) = (str[5])? atoi(str[5]):0;
	WFIFOB(sd->fd, 11) = (str[6])? atoi(str[6]):0;
	WFIFOB(sd->fd, 12) = (str[7])? atoi(str[7]):0;
	WFIFOB(sd->fd, 13) = (str[8])? atoi(str[8]):0;
	WFIFOB(sd->fd, 14) = (str[9])? atoi(str[9]):0;
	WFIFOB(sd->fd, 15) = (str[10])? atoi(str[10]):0;
	WFIFOB(sd->fd, 16) = (str[11])? atoi(str[11]):0;
	WFIFOB(sd->fd, 17) = (str[12])? atoi(str[12]):0;
	WFIFOB(sd->fd, 18) = (str[13])? atoi(str[13]):0;
	WFIFOB(sd->fd, 19) = (str[14])? atoi(str[14]):0;
	WFIFOSET(sd->fd, crypt(WFIFOP(sd->fd,0)) );
	printf("packet test\n");
}
int is_command(struct map_sessiondata *sd,const char *p, int len) {
	int i;
	char cmd_line[257];
	char *cmdp;
	if (*p!=command_code || sd->status.gm_level < 1)
		return 0;
	p++;
	//copy command to buffer
	memcpy(cmd_line,p,len);
	cmd_line[len]=0x00;
	cmdp = cmd_line;
	//Search for end of command string
	while(*cmdp!=' ' && *cmdp!='\0')
		cmdp++;
	//set null for comparement
	*cmdp='\0';
//	printf("findto: %s\n",cmd_line);
	for(i=0;command[i].func;i++) {
		if (!strcmpi(cmd_line,command[i].name)) 
			break;
	}
//	printf("found: %s\n",command[i].name);
	//wrong command, exit!
	if (command[i].func==NULL)
		return 0;
	//found command
	//skip our null terminate
	cmdp++;
	//let's go
	command[i].func(sd, cmdp);
	return 1;
}

int command_disguise(struct map_sessiondata *sd,char *line) {
	int d;
	int e;
	if (sscanf(line,"%d %d",&d,&e)<1)
		return -1;
	
	sd->disguise=d;
	sd->disguise_color=e;
	clif_sendchararea(sd);
	clif_getchararea(sd);

	return 0;
}
int command_warp(struct map_sessiondata *sd,char *line) {
	int m,x,y;
	if (sscanf(line,"%d %d %d",&m,&x,&y)<1)
		return -1;
	
	pc_warp(sd,m,x,y);
	return 0;
}
int command_debug(struct map_sessiondata *sd, char *line) {
	char *str[64],*p,*np;
	int strnum,i,skip,packnum;
	if (sscanf(line, "%d%n", &packnum, &skip) < 1)
		return -1;
	p=line+skip;
	while(*p && isspace(*p))
		p++;
	strnum=0;
	for(i=0,np=p;i<64 && p;i++) {
		str[i]=p;
		p=strchr(p,',');
		strnum++;
		if(p) {*p++=0; np=p;} 
		else {break;}
	}
	WFIFOB(sd->fd, 0)=0xAA;
	WFIFOW(sd->fd, 1)=SWAP16(strnum+2);
	WFIFOB(sd->fd, 3)=packnum;
	WFIFOB(sd->fd, 4)=0x03;
	for(i=0;i<strnum;i++)
		WFIFOB(sd->fd, 5+i)=atoi(str[i]);
	crypt(WFIFOP(sd->fd,0));
	WFIFOSET(sd->fd, strnum+5);
	return 0;
}

int command_item(struct map_sessiondata *sd, char *line) {
	struct item it;
	char itemname[32];
	int itemnum=0;
	int itemid=0;
	if (sscanf(line, "%31s %d", itemname, &itemnum)<1)
		return -1;
	itemid = itemdb_id(itemname);
	if (!itemid)
		return -1;

	if (itemnum<=0)
		itemnum=1;

	memset(&it,0,sizeof(struct item));
	it.id = itemid;
	it.dura = itemdb_dura(itemid);
	it.amount = itemnum;
	strcpy(it.real_name, itemdb_name(itemid));

	pc_additem(sd, &it);
	return 0;
}

int command_res(struct map_sessiondata *sd, char *line) {
	if (sd->status.state==PC_DIE)
		pc_res(sd);
	return 0;
}
int command_spell(struct map_sessiondata *sd, char *line) {
	int spell;
	if(sscanf(line,"%d",&spell)<1)
		return -1;
	
	map_foreachinarea(clif_sendanimation,sd->bl.m,sd->bl.x,sd->bl.y,AREA,BL_PC,spell,&sd->bl);
	//run_script(magicdb_script(spell),0,sd->bl.id,0);
	//clif_sendanimation(sd,spell);
	return 0;
}

int command_hair(struct map_sessiondata *sd, char *line) {
	int hair;
	int hair_color;
	if (sscanf(line, "%d %d",&hair,&hair_color)<1)
		return -1;
	
	sd->status.hair=hair;
	sd->status.hair_color=hair_color;
	clif_sendchararea(sd);
	clif_getchararea(sd);
	return 0;
}
int command_side(struct map_sessiondata *sd, char *line) {
	int side;
	if (sscanf(line, "%d",&side)<1)
		return -1;
	
	sd->status.side=side;
	clif_sendchararea(sd);
	clif_getchararea(sd);
	return 0;
}
int command_state(struct map_sessiondata *sd, char *line) {
	int state;
	if (sscanf(line, "%d",&state)<1)
		return -1;
	
	sd->status.state=state;
	clif_sendchararea(sd);
	clif_getchararea(sd);
	return 0;
}
int command_armorcolor(struct map_sessiondata *sd, char *line) {
	int armorcolor;
	if (sscanf(line, "%d",&armorcolor)<1)
		return -1;
	
	sd->status.armor_color=armorcolor;
	clif_sendchararea(sd);
	clif_getchararea(sd);
	return 0;
}

int command_givespell(struct map_sessiondata *sd, char *line) {
	int spell;
	char name[32];
	int x;
	if(sscanf(line,"%d",&spell)<1)
		return -1;

	for(x=0;x<26;x++) {
		if(sd->status.skill[x]==0) { //vacant spot
			sd->status.skill[x]=spell;
			pc_loadmagic(sd);
			return 0;
		}
	}
	return 0;
}


int command_val(struct map_sessiondata *sd, char *line) {
	int val;
	int valval;
	if(sscanf(line,"%d %d",&val,&valval)<1)
		return -1;
	
	//sd->val[val]=valval;
	clif_sendchararea(sd);
	clif_getchararea(sd);
	return 0;
}

int command_makegm(struct map_sessiondata *sd, char *line) {
	int name[32];
	struct map_sessiondata *tsd;
	if(sscanf(line,"%31s",&name)<1)
		return -1;
	
	tsd=map_name2sd(name);
	if(tsd) {	
	tsd->status.gm_level=99;
	}
	return 0;
}

	

int command_xprate(struct map_sessiondata *sd, char*line) {
	int rate;
	char buf[256];
	int len;
	
	if (sscanf(line,"%d",&rate)<1)
		return -1;
	
	len=sprintf(buf,"Experience rate: %u x",rate);
	clif_sendminitext(sd,buf,len);
	xp_rate=rate;
	
	return 0;
}
int command_drate(struct map_sessiondata *sd, char *line) {
	int rate;
	char buf[256];
	int len;
	
	if (sscanf(line,"%d",&rate)<1)
		return -1;
	
	len=sprintf(buf,"Drop rate: %u x",rate);
	clif_sendminitext(sd,buf,len);
	d_rate=rate;
	return 0;
}
int command_who(struct map_sessiondata *sd, char *line) {
	int len;
	char buf[256];
	
	len=sprintf(buf,"There are %d users online.",userlist.user_count);
	clif_sendminitext(sd,buf,len);
	return 0;
}

int command_heal(struct map_sessiondata *sd, char *line) {
	sd->status.hp=sd->max_hp;
	sd->status.mp=sd->max_mp;
	clif_sendstatus(sd);
	return 0;
}
int command_level(struct map_sessiondata *sd, char *line) {
	int level;
	if (sscanf(line,"%d",&level)<1)
		return -1;
	
	sd->status.level=level;
	clif_sendstatus(sd);
	return 0;
}
int command_mon(struct map_sessiondata *sd, char *line) {
	int id;
	if (sscanf(line,"%d",&id)<1)
		return -1;
	
	mobspawn_onetime(id,sd->bl.m,sd->bl.x,sd->bl.y);
	return 0;
}

int command_sound(struct map_sessiondata *sd, char *line) {
	int id;
	if (sscanf(line,"%d",&id)<1)
		return -1;
	clif_sendsound(sd,id);
	return 0;
}


int command_randomspawn(struct map_sessiondata *sd, char *line) {
	int x;
	int y;
	int m;
	int id;
	int times;
	int z;
	int a;
	int max;
	char buf[255];
	if (sscanf(line,"%d %d",&id,&times)<1)
		return -1;
	
	m=sd->bl.m;
	max=map[m].block_mob_count+1;
	for(z=0;z<times;z++) {
	reloopit:
		x=rand()%map[m].xs;
		y=rand()%map[m].ys;
		
		for(a=1;a<max;a++){
			if(map[m].block_mob[a]->startx==x && map[m].block_mob[a]->starty==y)
				goto reloopit;
		}
		
		mobspawn_onetime(id,m,x,y);
			
	}
	
	//z=sprintf(buf,"Added %d spawns.",times);
	//clif_sendbluemessage(sd,buf,z);
	return 0;
}

int command_scriptreload(struct map_sessiondata *sd, char* a) {

	script_reload();
	npc_init_sub();
	clif_sendmsg(sd,3,"ε",6);
}
int command_worldmaptest(struct map_sessiondata *sd, char *a) {
	clif_send_worldmap(sd);
}
int at_command(struct map_sessiondata *sd,const char *p, int len) {
	int i;
	char cmd_line[257];
	char *cmdp;
	if (*p!=command_code)
		return 0;
	p++;
	//copy command to buffer
	memcpy(cmd_line,p,len);
	cmd_line[len]=0x00;
	cmdp = cmd_line;
	//Search for end of command string
	while(*cmdp!=' ' && *cmdp!='\0')
		cmdp++;
	//set null for comparement
	*cmdp='\0';
	for(i=0;command[i].func;i++) {
		if (!strcmpi(cmd_line,command[i].name))
			break;
	}
	//wrong command, exit!
	if (command[i].func==NULL)
		return 0;
	//found command
	//skip our null terminate
	cmdp++;
	//let's go
	command[i].func(sd, cmdp);
	return 1;
}
int command_addlegend(struct map_sessiondata *sd, char* line) {
	char p[50][256];
	sscanf(line,"%s %s %s %s",p[0],p[1],p[2],p[3]);
	pc_addlegend(sd, atoi(p[0]), atoi(p[1]), p[2]);
}
int command_dellegend(struct map_sessiondata *sd, char* line) {
	char p[50][256];
	sscanf(line,"%s %s %s %s",p[0],p[1],p[2],p[3]);
	pc_dellegend(sd, p[0]);
}
int command_modifylegend(struct map_sessiondata *sd, char* line) {
	char p[50][256];
	sscanf(line,"%s %s %s %s",p[0],p[1],p[2],p[3]);
	pc_modifylegend(sd, atoi(p[0]), atoi(p[1]), p[2], p[3]);
}
