// trade system


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "../common/malloc.h"
#include "../common/nullpo.h"
#include "../common/db.h"
#include "../common/timer.h"
#include "../common/ers.h"
#include "../common/malloc.h"
#include "../common/socket.h"
#include "../common/crypt.h"
#include "map.h"
#include "npc.h"
#include "script.h"
#include "magic.h"
#include "group.h"
#include "pc.h"
#include "clif.h"

int group_promote(struct map_sessiondata *sd, struct map_sessiondata *tsd);
int group_sendmember(struct map_sessiondata *sd);
int group_addmember(struct group_data *gd, struct map_sessiondata *tsd);
int group_delmember(struct group_data *gd, struct map_sessiondata *tsd);
void group_dissolve(struct group_data *gd);
int group_search_newleader(struct group_data *gd, int nowleader);
int fast_sendmsg(struct map_sessiondata *sd, char msg[], int option) {
	int size = strlen(msg);
	clif_sendmsg(sd, option, msg, size);
}


int group_sendmember(struct map_sessiondata *sd)
{
//	memcpy(WFIFOP(sd->fd,0),"\xAA\x00\x47\x63\x4B\x07\x2C\x39\x7D\x4A\x71\x4D\x5D\x08\x6D\x5B\x41\x50\x24\x03\xFC\x73\x61\x07\x2D\x31\x26\x2D\x03\xD8\xD5\x67\xF9\xD2\x30\x27\x26\x40\x49\x2B\x66\x40\x45\x32\x42\x44\x7E\x54\x5F\x60\x00\xE1\x14\x21\xDF\xF8\x20\xD2\x9F\x03\xD7\xCA\x22\xDC\xFB\x23\x2E\x63\x02\x4D\x34\x23\x22\x61",71);
//	WFIFOSET(sd->fd, 71);

//ӽù 
	
	int i;
	struct group_data *gd;


	
	WFIFOB(sd->fd,0)=0xAA;
	WFIFOB(sd->fd,3)=0x63;
	WFIFOB(sd->fd,4)=0;
	WFIFOB(sd->fd,5)=3;

	WFIFOB(sd->fd,6)=3;
	WFIFOB(sd->fd,7)=1;
	WFIFOB(sd->fd,8)='a';
	WFIFOB(sd->fd,9)=0; //ǥ
	WFIFOB(sd->fd,10)=30;//Ӹ
	WFIFOB(sd->fd,11)=0;//Ӹ
	WFIFOB(sd->fd,12)=3; //
	WFIFOB(sd->fd,13)=1; //ʿ
	WFIFOB(sd->fd,14)=5>>8;
	WFIFOB(sd->fd,15)=5%256;//
	WFIFOB(sd->fd,16)=1; //⿰
	WFIFOB(sd->fd,17)=12>>8;
	WFIFOB(sd->fd,18)=12%256;// 
	WFIFOB(sd->fd,19)=1;//п 
	WFIFOB(sd->fd,20)=1;//̱
	WFIFOB(sd->fd,21)=2;//ȣ
	WFIFOB(sd->fd,22)=1;//
	WFIFOB(sd->fd,23)=4>>8;//
	WFIFOB(sd->fd,24)=4%256;// 
	WFIFOB(sd->fd,25)=1;//Ŀ
	WFIFOB(sd->fd,26)=50>>8;
	WFIFOB(sd->fd,27)=50%256;
	WFIFOB(sd->fd,28)=0;

    WFIFOW(sd->fd,1)=SWAP16(28);
    WFIFOSET(sd->fd,crypt(WFIFOP(sd->fd,0)));
	
	printf("´µ..\n");
	if(sd->group_info == NULL) {
		clif_sendminitext(sd, map_msg[MAP_GROUP_NOTJOIND].message, map_msg[MAP_GROUP_NOTJOIND].len);
		return 0;
	}

	gd = sd->group_info;
	fast_sendmsg(sd, "- ׷-",3);

	for(i=0; i<MAX_MEMBER; i++) {
		if(gd->member[i] != NULL) {
			fast_sendmsg(sd, gd->member[i]->status.name ,3);
		}
	}

	fast_sendmsg(sd, "-----------------",3);


}

int group_addmember(struct group_data *gd, struct map_sessiondata *tsd) {
	int i;
	int room;
	char msg[256]={0,};

	if(gd == NULL || tsd == NULL) {
		ShowError("Wrong! group_addmember()\n");
		return 0;
	}
	if(gd->membercount==MAX_MEMBER) {
		ShowInfo("ڸ ϴ:%d\n",gd->membercount);
		return 0;
	}
	
	room = group_aquire(gd);
	if(room < 0) {
		ShowInfo("īƮ ۰ ڸ \n");
		return 0;
	}
	
	sprintf(msg, "%s ׷ ",tsd->status.name);
	
	gd->member[room] = tsd;
	tsd->group_info = gd;
	gd->membercount++;
	
	for(i=0; i<MAX_MEMBER; i++) {
		if(gd->member[i]) {
			fast_sendmsg(gd->member[i],msg,3);
		}
	}
	
}

int group_delmember(struct group_data *gd, struct map_sessiondata *tsd) {
	int i;
	int newleader;
	int target = -1;
	char msg[256]={0,};
	int len;
	target = group_sd2room(tsd);
	if(target < 0) {
		return 0;
	}

	len=sprintf(msg, map_msg[MAP_GROUP_OUT].message, tsd->status.name);
	
	for(i=0; i<MAX_MEMBER; i++) {
		if(gd->member[i]) {
			clif_sendminitext(gd->member[i], msg, len);
		}
	}

	if(gd->member[target]->group_leader && gd->membercount >= 3) {
		newleader = group_search_newleader(gd, target);
		if(newleader >= 0) {
			gd->member[newleader]->group_leader = TRUE;
			fast_sendmsg(gd->member[newleader],"׷ ڸ ޾ҽϴ",3);
		}
	}

	gd->member[target]->group_info = NULL;
	gd->member[target]->group_leader = FALSE;
	gd->member[target] = NULL;
	
	gd->membercount--;

	if(gd->membercount < 2) {
		group_dissolve(gd);
	}
}

int group_promote(struct map_sessiondata *sd, struct map_sessiondata *tsd)
{
	struct group_data *gd;
	char msg[256]={0,};
	int len;
	CREATE(gd, struct group_data, 1);
	sd->group_info = gd;
	tsd->group_info = gd;
	
	sd->group_leader = TRUE;
	
	gd->member[0]=sd;
	gd->member[1]=tsd;
	gd->membercount=2;
	
	len=sprintf(msg,map_msg[MAP_GROUP_JOIN].message, sd->status.name);
	clif_sendminitext(sd, msg, len);
	len=sprintf(msg,map_msg[MAP_GROUP_JOIN].message, tsd->status.name);
	clif_sendminitext(sd, msg, len);
	clif_sendminitext(tsd, msg, len);
}

void group_dissolve(struct group_data *gd) {
	int i;
	for(i=0; i<MAX_MEMBER; i++) {
		if(gd->member[i]){
			break;
		}
	}

	fast_sendmsg(gd->member[i],"׷ ü",3);

	gd->member[i]->group_info = NULL;
	gd->member[i]->group_leader = FALSE;
	aFree(gd);
}
int clif_parsegroup(struct map_sessiondata *sd) {
	int fd=sd->fd;
	struct map_sessiondata *tsd;
	char name[NAME_LENGTH]={0,};

	memcpy(name, RFIFOP(fd, 6), RFIFOB(fd, 5));
	if(strcmp(name, sd->status.name) == 0) {
		clif_sendminitext(sd, map_msg[MAP_GROUP_NOTOSELF].message, map_msg[MAP_GROUP_NOTOSELF].len);
		return 0;
	}
	tsd= map_name2sd(name);
	if(tsd == NULL) {
		clif_sendminitext(sd, map_msg[MAP_GROUP_NOTEXIST_P].message, map_msg[MAP_GROUP_NOTEXIST_P].len);
		return 0;
	}
	if(tsd->status.opt.al_group == FALSE) {
		clif_sendminitext(sd, map_msg[MAP_GROUP_NOTALLOWED_P].message, map_msg[MAP_GROUP_NOTALLOWED_P].len);
		return 0;
	}
	
	if(tsd->group_info) {
		if(tsd->group_info == sd->group_info) {
			if(sd->group_leader) {
				group_delmember(sd->group_info, tsd);
				return 0;
			}
		}
		clif_sendminitext(sd, map_msg[MAP_GROUP_ALREADYJOIN].message, map_msg[MAP_GROUP_ALREADYJOIN].len);
		return 0;
	}

	if(sd->group_info) {
		group_addmember(sd->group_info, tsd);
	} else {
		// make a group
		if(sd->status.opt.al_group != TRUE) {
			sd->status.opt.al_group = TRUE;
			 clif_sendminitext(sd, map_msg[MAP_GROUP_ON].message, map_msg[MAP_GROUP_ON].len);
		}
		group_promote(sd, tsd);
	}

	return 1;

}

int group_aquire(struct group_data *gd) {
	int i;
	for(i=0; i<MAX_MEMBER; i++) {
		if(gd->member[i]==NULL) 
			return i;
	}
	return -1;
}

int group_search_newleader(struct group_data *gd, int nowleader) {
	int i;
	for(i=0; i<MAX_MEMBER; i++) {
		if(gd->member[i] && nowleader != i) {
			return i;
		}
	}

	return -1;
}

int group_sd2room(struct map_sessiondata *sd) {
	int i;
	struct group_data *gd;
	if(sd->group_info == NULL) return -1;
	
	gd = sd->group_info;

	for(i=0; i<MAX_MEMBER; i++) {
		if(gd->member[i] == sd) {
			return i;
		}
	}

	return -1;
}