
#ifndef _NPC_H_
#define _NPC_H_

int npc_src_clear();
int npc_src_add(const char*);
int npc_parse_warp(char*,char*,char*,char*);
int npc_init();
int npc_scriptcont(struct map_sessiondata*,int,int);
struct npc_data* npc_name2id(const char *name);
int npc_event_dequeue(struct map_sessiondata *sd);
int npc_gettimerevent_tick(struct npc_data *nd);
int npc_enable(const char *name,int flag);
int npc_do_ontimer(int npc_id, int option);
int npc_deleventtimer(struct npc_data *nd,const unsigned char *name);
int npc_cleareventtimer(struct npc_data *nd);
int npc_event_timer(int tid,unsigned int tick,int id,int data);
int npc_timer_event(const unsigned char *eventname);	// Added by RoVeRT
int npc_event (struct map_sessiondata *sd, const unsigned char *eventname, int mob_kill);
int npc_addeventtimer(struct npc_data *nd,int tick,const char *name);
int npc_timerevent_stop(struct npc_data *nd);
int npc_settimerevent_tick(struct npc_data *nd,int newtimer);
int npc_gettimerevent_tick(struct npc_data *nd);
int npc_event_do_oninit(void);
int npc_event_do_clock(int tid,unsigned int tick,int id,int data);
int npc_event_do(const unsigned char *name);
int npc_timerevent(int tid,unsigned int tick,int id,int data);
int npc_event_doall(const unsigned char *name);
int npc_event_doall_id(const unsigned char *name, int rid);
int npc_settimerevent_tick(struct npc_data *nd,int newtimer);
int npc_gettimerevent_tick(struct npc_data *nd);
void npc_timerevent_quit(struct map_sessiondata *sd);
int npc_timerevent_stop(struct npc_data *nd);
int npc_timerevent_start(struct npc_data *nd, int rid);
int npc_final();

extern struct npc_shop_data *npc_shop[0xFFFF];


#define npcshop_id(id) (npc_shop[id])? npc_shop[id]->id : 0
#define npcshop_itemcount(id) (npc_shop[id])? npc_shop[id]->itemcount : 0
#define npcshop_itemid(id,count) (npc_shop[id])? npc_shop[id]->itemid[count] : 0
#define npcshop_buyprice(id,count) (npc_shop[id])? npc_shop[id]->buyprice[count] : 0
#define npcshop_sellprice(id,count) (npc_shop[id])? npc_shop[id]->sellprice[count] : 0
#endif

